package com.engine.salary.mapper.salarysob;

import com.engine.salary.entity.salarysob.param.SalarySobRangeEmpQueryParam;
import com.engine.salary.entity.salarysob.po.SalarySobRangePO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface SalarySobRangeMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<SalarySobRangePO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<SalarySobRangePO> listSome(SalarySobRangePO salarySobRange);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    SalarySobRangePO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param salarySobRange 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(SalarySobRangePO salarySobRange);

    /**
     * 修改，修改所有字段
     *
     * @param salarySobRange 修改的记录
     * @return 返回影响行数
     */
    int update(SalarySobRangePO salarySobRange);

    /**
     * 修改，忽略null字段
     *
     * @param salarySobRange 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(SalarySobRangePO salarySobRange);

    /**
     * 删除记录
     *
     * @param salarySobRange 待删除的记录
     * @return 返回影响行数
     */
    int delete(SalarySobRangePO salarySobRange);


    /**
     * 批量保存
     */
    void batchInsert(@Param("collection") Collection<SalarySobRangePO> salarySobRanges);

    /**
     * 按薪资账套id删除
     */
    void deleteBySalarySobIds(@Param("salarySobIds") Collection<Long> salarySobIds);

    /**
     * 按照主键id删除
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 获取薪资账套的适用人员
     */
    List<Long> listEmployeeIds(@Param("params") Collection<SalarySobRangeEmpQueryParam> params);

    /**
     * 更新人员状态使用逗号分割
     * @param item
     */
    void updateEmployeeStatuses(@Param("param") SalarySobRangePO item);
}